```@meta
CurrentModule = NaturalNeighbours
```

# NaturalNeighbours

Documentation for [NaturalNeighbours](https://github.com/DanielVandH/NaturalNeighbours.jl).

This is a package for working with natural neighbours of planar point sets, enabling scattered data (or spatial) interpolation via [natural neighbour interpolation](https://en.wikipedia.org/wiki/Natural_neighbor_interpolation), as well as derivative generation. We use [DelaunayTriangulation.jl](https://github.com/DanielVandH/DelaunayTriangulation.jl) to define the spatial information. Much of the work in this package is based on [this great thesis](https://kluedo.ub.rptu.de/frontdoor/deliver/index/docId/2104/file/diss.bobach.natural.neighbor.20090615.pdf).

Please see the sections in the sidebar for some more discussion. The relevant docstrings for this package are shown below.

```@docs
interpolate
differentiate 
generate_gradients
generate_derivatives
AbstractInterpolator
AbstractDifferentiator
Sibson
Hiyoshi
Farin
Laplace
Triangle
Nearest
Direct
Iterative
identify_exterior_points
```
